package com.example.switchyard.BpmEqSearch;

import org.switchyard.annotations.Transformer;
import org.w3c.dom.Document;

import java.io.StringReader;

import javax.xml.transform.dom.DOMResult;
import javax.xml.transform.sax.SAXTransformerFactory;
import javax.xml.transform.stream.StreamSource;


import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
public final class Txf {




	
    private static final String COMPANY_ID = "companyId";
		private static final String USR_ID = "usrId";
		private static final String PASSWORD = "password";
		private static final String LANGUAGE = "language";
		private static final String DATA = "data";
		
		
	
	@Transformer(to = "{http://www.smartering.org/smartd/EquipmentConfigurationServices}equipmentSearchSoa")
	public Element transformStringToEquipmentSearchSoa(String from) {
		System.out.println("-------STEP 0 --------");
		System.out.println(from + " 0000000");
		StringBuffer xml = new StringBuffer()
		.append("<equipmentSearchSoa>")
		.append(  "<string>" + from + "</string>")
		.append("</equipmentSearchSoa>");
		return toElement(xml.toString());
	}

	@Transformer(to = "{urn:com.example.switchyard:BpmEqSearch:1.0}searchEquipmentSoaResponse")
	public Element transformStringToSearchEquipmentSoaResponse(String from) {
		System.out.println("---------STEP 1 --------------" );
		System.out.println(from );
		StringBuffer ackXml = new StringBuffer()
	
		.append("<searchEquipmentSoaResponse>"+  from +  "</searchEquipmentSoaResponse>" );
		
		return toElement(ackXml.toString());
	}

	@Transformer(from = "{http://www.smartering.org/smartd/EquipmentConfigurationServices}equipmentSearchSoaResponse")
	public String transformEquipmentSearchSoaResponseToString(Element from) {
		System.out.println("------STEP2------");
		System.out.println(getElementValue(from, "equipmentSearchSoaResponse"));

		return getElementValue(from, "equipmentSearchSoaReturn");
		
	}
	
	@Transformer(from = "{urn:com.example.switchyard:BpmEqSearch:1.0}searchEquipmentSoa")
	public Input transformSearchEquipmentSoaToInput(Element from) {
		
		 return new Input()
		 .setPassword(getElementValue(from, PASSWORD))
		 .setData(getElementValue(from, DATA))
		 .setUsrId(getElementValue(from, USR_ID))
         .setCompanyId(getElementValue(from, COMPANY_ID))
         .setLanguage(getElementValue(from, LANGUAGE));
  
	}
	
	
	
	  private String getElementValue(Element parent, String elementName) {
	        String value = null;
	        NodeList nodes = parent.getElementsByTagName(elementName);
	        if (nodes.getLength() > 0) {
	            value = nodes.item(0).getChildNodes().item(0).getNodeValue();
	        }
	        System.out.println("********TXD *********" + elementName);
	        System.out.println(value);
	        return value;
	    }

	    private Element toElement(String xml) {
	        DOMResult dom = new DOMResult();
	        try {
	            SAXTransformerFactory.newInstance().newTransformer().transform(
	                    new StreamSource(new StringReader(xml)), dom);
	        } catch (Exception ex) {
	            ex.printStackTrace();
	        }

	        return ((Document)dom.getNode()).getDocumentElement();
	    }

	
		
		

}
